"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AcceptLanguageResolver = void 0;
const common_1 = require("@nestjs/common");
const accept_language_parser_1 = require("accept-language-parser");
let AcceptLanguageResolver = class AcceptLanguageResolver {
    async resolve(context) {
        var _a, _b, _c;
        let req;
        let service;
        switch (context.getType()) {
            case 'http':
                req = context.switchToHttp().getRequest();
                service = req.i18nService;
                break;
            case 'graphql':
                [, , { req, i18nService: service }] = context.getArgs();
                if (!req)
                    return undefined;
                break;
            default:
                return undefined;
        }
        const lang = req.raw
            ? (_a = req.raw.headers) === null || _a === void 0 ? void 0 : _a['accept-language']
            : (_b = req === null || req === void 0 ? void 0 : req.headers) === null || _b === void 0 ? void 0 : _b['accept-language'];
        if (lang) {
            const supportedLangs = await service.getSupportedLanguages();
            return (_c = accept_language_parser_1.pick(supportedLangs, lang)) !== null && _c !== void 0 ? _c : accept_language_parser_1.pick(supportedLangs, lang, { loose: true });
        }
        return lang;
    }
};
AcceptLanguageResolver = __decorate([
    common_1.Injectable()
], AcceptLanguageResolver);
exports.AcceptLanguageResolver = AcceptLanguageResolver;
//# sourceMappingURL=accept-language.resolver.js.map